package classes.PathData;

import java.util.*;
import classes.PathData.*;


public class k_thCdPathList {
	
	private k_thCdPath first;
	private k_thCdPath last;
	
	private int mainCost;
	private LinkedList mainPath;
	
	private int totalNum;
	private int n;
	
	public k_thCdPathList(int max) {
		first = null;
		last = null;
		totalNum = max-1;
		n = 0;
	}
	
	
	public boolean isEmpty() {
		return first == null;
	}
	
	
	public void insertKCPL(int CdCost, LinkedList CdPath, int k) {
		k_thCdPath newPath = new k_thCdPath(CdPath,CdCost);
		k_thCdPath current = first;
		
		while(current != null && CdCost > current.CdCost) {
			current = current.next;
		}
		
		if(current == first) {
			if( isEmpty() ) {
				last = newPath;
			}
			else {
				first.previous = newPath;
			}
			newPath.next = first;
			first = newPath;
		}
		else if(current == null) {
			last.next = newPath;
			newPath.previous = last;
			last = newPath;
		}
		else {
			newPath.next = current;
			newPath.previous = current.previous;
			current.previous.next = newPath;
			current.previous = newPath;
		}
		
		n++;
		int N = totalNum - k;
		
		while( n > N ) {
			deleteLastKCPL();
			n--;
		}
		
	//	System.out.println("Ǘ " + N + " k: " + k + " ݊Ǘ " + n );
		
	}
	
	
	public void decisionKCPL() {
		k_thCdPath temp = first;
		if(first.next == null)
			last = null;
		else
			first.next.previous = null;
		first = first.next;
		
		mainCost = temp.CdCost;
		mainPath = temp.CdPath;
		
		n--;
	}
	
	
	public int ReturnCost() {
		return mainCost;
	}
	
	
	public LinkedList ReturnPath() {
		return mainPath;
	}
	
	
	public void deleteLastKCPL() {
		k_thCdPath temp = last;
		if(first.next == null)
			first = null;
		else
			last.previous.next = null;
		last = last.previous;
	}
	
	
	public void displayKCPL() {
		k_thCdPath current = first;
		while(current != null) {
			current.displayKCP();
			current = current.next;
		}
		
		System.out.println();
	}
	
	
	public boolean LoopCheckKCPL(LinkedList CdPath) {
		
		LinkedList templist = new LinkedList();
		ListIterator lst_itr = CdPath.listIterator(0);
		
		while(lst_itr.hasNext()) {
			templist.add(new Integer(((Integer)lst_itr.next()).intValue()));
		}
		
		
		int N = CdPath.size();
		
		for(int i=1; i<N-1; i++) {
			for(int j=1; j<N-1; j++) {
				if(i != j) {
					if( ((Integer)CdPath.get(i)).intValue() == ((Integer)templist.get(j)).intValue() )
						return false;
				}
			}
		}
		return true;
	}
	
	
	public boolean Judgement(int key, LinkedList Cost) {
		k_thCdPath current = first;
		
		while(true) {
			
			if(current == null) {
				return true;
			}
			else if(key == current.CdCost) {
				if(Cost.equals(current.CdPath)) {
					return false;
				}
			}
//			else if(key > current.CdCost) {
//				return true;
//			}
			else if(key < current.CdCost) {
				return true;
			}
			
			current = current.next;
		}
	}
	
}
