package classes.PathData;

import java.util.*;
import java.io.*;
import classes.Data.*;
import classes.PathData.*;

public class k_thPathArray {
	private k_thPathData[] kpd;
	int n;
	
	
	public k_thPathArray(int max) {
		kpd = new k_thPathData[max];
		n = 0;
	}
	
	
	public void insertKPA(int mC, LinkedList mP) {
		kpd[n] = new k_thPathData(mC, mP);
		n++;
	}
	
	
	public boolean Judgement(int mC, LinkedList mP) {
		
		if(kpd[n-1].mainCost == mC) {
			for(int j=0; j<n-1; j++) {
				if((kpd[j].mainPath).equals(mP))
					return false;
			}
		}
		else{
			return true;
		}
		
		return true;
	}
	
	
	public int PathSize(int k) {
		return kpd[k].mainPath.size();
	}
	
	public int ReturnCost(int k) {
		return kpd[k].mainCost;
	}
	
	public int PathelementNum(int k, int nc) {
		int pen = ((Integer)kpd[k].mainPath.get(nc)).intValue();
		return pen;
	}
	
	public void OverlapEliminate1(int Asp2, LinkList[] alllink, PositionPoint[] point, PositionPoint[] allpoint, LinkedList CRPath) {
		
		double Overlap = (double) Asp2/100;
		int SNC = CRPath.size();
		int SCost = 0;
		
		for(int i=0; i<SNC-1; i++) {
			int n1 = ((Integer)CRPath.get(i)).intValue();
			int n2 = ((Integer)CRPath.get(i+1)).intValue();
			SCost = SCost + alllink[n1].findReturnCostLink(n2);
		}
		
		for(int j=0; j<n; j++) {
			
			if(kpd[j].EBA1) {
				int CNC = PathSize(j);
				int OlpCost = 0;
				Loop: for(int snc=0; snc<SNC-1; snc++) {
						for(int cnc=0; cnc<CNC-1; cnc++) {
							int SStrNodeNum = ((Integer)CRPath.get(snc)).intValue();
							int SEndNodeNum = ((Integer)CRPath.get(snc+1)).intValue();
							int CStrNodeNum = PathelementNum(j,cnc);
							int CEndNodeNum = PathelementNum(j,cnc+1);
							
							int SStrNodeNum1 = allpoint[((Integer)CRPath.get(snc)).intValue()].number;
							int SEndNodeNum1 = allpoint[((Integer)CRPath.get(snc+1)).intValue()].number;
							int CStrNodeNum1 = point[PathelementNum(j,cnc)].number;
							int CEndNodeNum1 = point[PathelementNum(j,cnc+1)].number;
							
							if( SStrNodeNum1==CStrNodeNum1 && SEndNodeNum1==CEndNodeNum1 ) {
								OlpCost = 
									OlpCost + alllink[SStrNodeNum].findReturnCostLink(SEndNodeNum);
								
//								System.out.println("d = "+  ( ((double)OlpCost/SCost) ) );
								
								if( ((double)OlpCost/SCost) > Overlap ) {
									kpd[j].EBA1 = false;
//									System.out.println(CRPath);  kpd[j].displayk_thPathData();
//									System.out.println(kpd[j].EBA1);
									break Loop;
								}
							}
						}
					//	System.out.println("CPath:" + kpd[j].mainPath);
				}
			}
					
		}
	}
	
	
	
	
	
	public void OverlapEliminate(int Asp2, LinkList[] link) {
		
		double Overlap = (double) Asp2/100;
		
		for(int i=0; i<n; i++) {
			
			if(kpd[i].EBA1) {
				int SNC = PathSize(i);
				int SCost = ReturnCost(i);
				
				for(int j=1; j<n; j++) {
					if(i < j) {
					if(kpd[j].EBA1) {
						
						int CNC = PathSize(j);
						int OlpCost = 0;
						
						Loop: for(int snc=0; snc<SNC-1; snc++) {
							for(int cnc=0; cnc<CNC-1; cnc++) {
								
								int SStrNodeNum = PathelementNum(i,snc);
								int SEndNodeNum = PathelementNum(i,snc+1);
								int CStrNodeNum = PathelementNum(j,cnc);
								int CEndNodeNum = PathelementNum(j,cnc+1);
								
								if( SStrNodeNum==CStrNodeNum && SEndNodeNum==CEndNodeNum ) {
									OlpCost = 
										OlpCost + link[SStrNodeNum].findReturnCostLink(SEndNodeNum);
									
									if( ((double)OlpCost/SCost) > Overlap ) {
										kpd[j].EBA1 = false;
										break Loop;
									}
								}
							}
						//	System.out.println("CPath:" + kpd[j].mainPath);
						}
					}
					}
				}
			}
		}
	}
	
	
	public void displayKPA() {
		for(int j=0; j<n; j++)
			kpd[j].displayk_thPathData();
	}
	
	
	public void PrintKPA(int Origin, int Destination, PositionPoint[] point, int[][] linkDATA) {
		
		try{
			PrintWriter pw = 
				new PrintWriter(new BufferedWriter(new FileWriter("/workspace/y-path1/Output/path.dat",true)));
			
//			pw.println("[Path Table]:" + n);
//			pw.println("{");
			
			for(int j=0; j<n; j++) {
				Constant.pathID++;
				pw.print("{ " + Constant.pathID + " " + Origin + " " + Destination + " { ");
							System.out.println(Constant.pathID);
				
				
				int NC = kpd[j].mainPath.size();
				
				for(int nc=0; nc<NC-1; nc++) {
					
					int startNum = point[ ((Integer)kpd[j].mainPath.get(nc)).intValue() ].number;
					int endNum   = point[ ((Integer)kpd[j].mainPath.get(nc+1)).intValue() ].number;
					
					for(int s=0; s<linkDATA.length; s++) {
						if(startNum == linkDATA[s][1] && endNum == linkDATA[s][2]) {
							pw.print(linkDATA[s][0]);
							if(nc+1<NC-1){
//								System.out.println("nc:" + nc + " NC:" + NC);
								pw.print(" ");
							}
						}
					}
				}
				pw.println(" } " + kpd[j].mainCost + " }");
			}
			
//			pw.println("}");
			
			pw.close();
		}
		catch(IOException e) {
			System.out.println(e);
		}
	}
	
	
	
	
	
	
	public void PrintKPA1(int Origin, int Destination, PositionPoint[] point, double Asp1) {
		try{
			PrintWriter pw = 
				new PrintWriter(new BufferedWriter(new FileWriter("Output/ksp.txt",true)));
			
			pw.print("Origin: " + Origin + " Destination: " + Destination);
			pw.println(" EBA: " + Asp1);
			
			
			for(int j=0; j<n; j++) {
				pw.print((j+1) + ",");
				pw.print(kpd[j].mainCost);
				pw.print(",");
				ListIterator lst_itr;
				lst_itr = kpd[j].mainPath.listIterator(0);
				while(lst_itr.hasNext()) {
					pw.print( point[ ((Integer)lst_itr.next()).intValue() ].number );
					pw.print(",");
				}
				pw.println();
			}
			
			pw.close();
		}
		catch(IOException e) {
			System.out.println(e);
		}
	}
	
	
	public void PrintKPA2(int Origin, int Destination, LinkList[] alllink, PositionPoint[] point, PositionPoint[] allpoint ,LinkedList CRPath, double Asp1, int Asp2) {
		try{
			PrintWriter pw = 
				new PrintWriter(new BufferedWriter(new FileWriter("Output/ksp(OLE).txt",true)));
			
			pw.print("Origin: " + Origin + " Destination: " + Destination);
			pw.println(" EBA1: " + Asp1 + " EBA2: " + Asp2 + "");
			
			int SNC = CRPath.size();
			int SCost = 0;
			
			for(int i=0; i<SNC-1; i++) {
				int n1 = ((Integer)CRPath.get(i)).intValue();
				int n2 = ((Integer)CRPath.get(i+1)).intValue();
				SCost = SCost + alllink[n1].findReturnCostLink(n2);
			}
			
			pw.print("0,");
			pw.print(SCost);
			pw.print(",");
			ListIterator lst_itr1;
			lst_itr1 = CRPath.listIterator(0);
			while(lst_itr1.hasNext()) {
				pw.print( allpoint[ ((Integer)lst_itr1.next()).intValue() ].number );
				pw.print(",");
			}
			pw.println();
			
			
			
			
			int I=0;
			for(int j=0; j<n; j++) {
				
				if(kpd[j].EBA1) {
					
					pw.print((++I) + ",");
					pw.print(kpd[j].mainCost);
					pw.print(",");
					ListIterator lst_itr;
					lst_itr = kpd[j].mainPath.listIterator(0);
					while(lst_itr.hasNext()) {
						pw.print( point[ ((Integer)lst_itr.next()).intValue() ].number );
						pw.print(",");
					}
					pw.println();
				}
			}
			
			pw.close();
		}
		catch(IOException e) {
			System.out.println(e);
		}
	}
	
}
